var declare = require('decl/declare'),
    Service = require('./Service'),
    ConfigService = require('./ConfigService'),
    ServiceManager = require('./ServiceManager');

module.exports = declare({
    /**
     * @extends Service
     */
    extend: Service,

    /**
     * The config hash passed to configure.
     *
     * @var {Object}
     */
    applicationConfig: null,

    /**
     * @var {ConfigService}
     */
    configService: null,

    /**
     * Fetch and return the serviceManager
     *
     * @return {ServiceManager}
     */
    getServiceManager: function () {
        if (this.serviceManager === null) {
            this.serviceManager = new ServiceManager;
        }

        return serviceManager;
    },

    getConfigService: function() {
        return this.configService;
    },

    setConfigService: function(configService) {
        this.configService = configService;
    },

    /**
     * @inheritDoc
     */
    configure: function(config) {
        this.applicationConfig = config;

        return this;
    },

    /**
     * @todo use class constant when its supported by decl
     *
     * @inheritDoc
     */
    bootstrap: function() {
        var serviceManager = this.getServiceManager();

        if (serviceManager.has('app.config') === false) {

        }

        this.configService = serviceManager.get('app.config');
    }
});
